"""
一般国外著作作者前面需要加上国籍简写，但这个没有一个标准，所以临时编写本脚本。

1. 人口数较多的国家在简写上具有更高的优先级
2. 香港 澳门 台湾 中国 已移除
3. 某些简写如果在中文停用词里面，一般来说这个简写不太具有含义，不推荐使用，比如阿，哈，所，以，什么的

"""
import logging
from .stopwords import chinese_stopwords

logger = logging.getLogger(__name__)


country_population_rank = ['印度', '美国', '印度尼西亚', '巴基斯坦', '奈及利亚', '巴西', '孟加拉', '俄罗斯联邦',
                           '埃塞俄比亚', '墨西哥', '日本', '埃及', '菲律宾', '刚果民主共和国', '越南', '伊朗', '土耳其',
                           '德国', '泰国', '坦桑尼亚联合共和国', '英国', '法国', '南非', '意大利', '肯尼亚', '缅甸',
                           '哥伦比亚', '韩国', '苏丹', '乌干达', '西班牙', '阿尔及利亚', '伊拉克', '阿根廷', '阿富汗',
                           '也门', '加拿大', '安哥拉', '乌克兰', '摩洛哥', '波兰', '乌兹别克斯坦', '马来西亚',
                           '莫桑比克', '加纳', '秘鲁', '沙特阿拉伯', '马达加斯加', '科特迪瓦', '喀麦隆', '尼泊尔',
                           '委内瑞拉', '尼日尔', '澳大利亚', '朝鲜', '阿拉伯叙利亚共和国', '马里', '布基纳法索',
                           '斯里兰卡', '马拉维', '赞比亚', '乍得共和国', '哈萨克斯坦', '智利', '索马里',
                           '塞内加尔', '罗马尼亚', '危地马拉', '荷兰', '厄瓜多尔', '柬埔寨', '津巴布韦', '几内亚',
                           '贝宁', '卢旺达', '布隆迪', '玻利维亚', '突尼斯', '南苏丹', '海地', '比利时', '约旦',
                           '多明尼加共和国', '阿拉伯联合酋长国', '洪都拉斯', '古巴', '塔吉克斯坦', '巴布亚新几内亚',
                           '瑞典', '捷克', '葡萄牙', '阿塞拜疆', '希腊', '多哥', '匈牙利', '以色列', '奥地利',
                           '白俄罗斯', '瑞士', '塞拉利昂', '老挝人民民主共和国', '土库曼斯坦', '利比亚',
                           '吉尔吉斯斯坦', '巴拉圭', '尼加拉瓜', '保加利亚', '塞尔维亚', '刚果共和国', '萨尔瓦多',
                           '丹麦', '新加坡', '黎巴嫩', '利比里亚', '芬兰', '挪威', '巴勒斯坦国', '中非共和国', '阿曼',
                           '斯洛伐克', '毛里塔尼亚', '爱尔兰', '新西兰', '哥斯达黎加', '科威特', '巴拿马', '克罗地亚',
                           '格鲁吉亚', '厄立特里亚', '蒙古', '乌拉圭', '波多黎各', '波斯尼亚和黑塞哥维那', '卡塔尔',
                           '纳米比亚', '摩尔多瓦共和国', '亚美尼亚', '牙买加', '立陶宛', '冈比亚', '阿尔巴尼亚', '加蓬',
                           '博茨瓦纳', '莱索托', '几内亚比绍', '斯洛文尼亚', '赤道几内亚', '拉脱维亚', '北马其顿',
                           '巴林', '特立尼达和多巴哥', '东帝汶', '塞浦路斯', '爱沙尼亚', '毛里求斯', '埃斯瓦蒂尼',
                           '吉布地', '斐济', '科摩罗', '留尼汪', '所罗门群岛', '圭亚那', '不丹', '卢森堡',
                           '苏里南', '黑山共和国', '西撒哈拉', '马耳他', '马尔代夫', '佛得角', '文莱达鲁萨兰国',
                           '伯利兹', '巴哈马', '冰岛', '瓜德罗普', '马提尼克岛', '马约特岛', '瓦努阿图', '法属圭亚那',
                           '新喀里多尼亚', '巴巴多斯', '法属波利尼西亚', '圣多美和普林西比', '萨摩亚', '库拉索',
                           '圣卢西亚', '关岛', '基里巴斯', '塞舌尔', '格林纳达', '密克罗尼西亚联邦', '阿鲁巴岛', '汤加',
                           '圣文森特和格林纳丁斯', '安提瓜和巴布达', '美属维尔京群岛']

_country_zh_abbr_dict = {}
_already_taken = set()
_use_full_name_country = []
_discard_zh_abbr = set()


def _process_data():
    for full_country_name in country_population_rank:
        country_zh_abbr = full_country_name[0]
        if country_zh_abbr in chinese_stopwords:
            _discard_zh_abbr.add(country_zh_abbr)

        if country_zh_abbr in _already_taken or (country_zh_abbr in _discard_zh_abbr):
            country_zh_abbr = full_country_name
            _country_zh_abbr_dict[country_zh_abbr] = full_country_name
            _use_full_name_country.append(full_country_name)
        else:
            _country_zh_abbr_dict[country_zh_abbr] = full_country_name
            _already_taken.add(country_zh_abbr)


# _process_data()

country_zh_abbr_dict = {'不': '不丹', '东': '东帝汶', '中': '中非共和国', '丹': '丹麦', '乌': '乌干达',
                        '乌克兰': '乌克兰', '乌兹别克斯坦': '乌兹别克斯坦', '乌拉圭': '乌拉圭', '乍': '乍得共和国',
                        '也门': '也门', '亚': '亚美尼亚', '以色列': '以色列', '伊': '伊朗', '伊拉克': '伊拉克',
                        '伯': '伯利兹', '佛': '佛得角', '俄': '俄罗斯联邦', '保': '保加利亚', '克': '克罗地亚',
                        '关': '关岛', '冈': '冈比亚', '冰': '冰岛', '几内亚': '几内亚', '几内亚比绍': '几内亚比绍',
                        '刚': '刚果民主共和国', '刚果共和国': '刚果共和国', '利': '利比亚', '利比里亚': '利比里亚',
                        '加': '加拿大', '加纳': '加纳', '加蓬': '加蓬', '匈': '匈牙利', '北': '北马其顿', '南': '南非',
                        '南苏丹': '南苏丹', '博': '博茨瓦纳', '卡': '卡塔尔', '卢': '卢旺达', '卢森堡': '卢森堡',
                        '印': '印度', '印度尼西亚': '印度尼西亚', '危': '危地马拉', '厄': '厄瓜多尔',
                        '厄立特里亚': '厄立特里亚', '古': '古巴', '吉': '吉尔吉斯斯坦', '吉布地': '吉布地',
                        '哈萨克斯坦': '哈萨克斯坦', '哥': '哥伦比亚', '哥斯达黎加': '哥斯达黎加', '喀': '喀麦隆',
                        '土': '土耳其', '土库曼斯坦': '土库曼斯坦', '圣': '圣多美和普林西比', '圣卢西亚': '圣卢西亚',
                        '圣文森特和格林纳丁斯': '圣文森特和格林纳丁斯', '圭': '圭亚那', '坦': '坦桑尼亚联合共和国',
                        '埃': '埃塞俄比亚', '埃及': '埃及', '埃斯瓦蒂尼': '埃斯瓦蒂尼', '基': '基里巴斯',
                        '塔': '塔吉克斯坦', '塞': '塞内加尔', '塞尔维亚': '塞尔维亚', '塞拉利昂': '塞拉利昂',
                        '塞浦路斯': '塞浦路斯', '塞舌尔': '塞舌尔', '墨': '墨西哥', '多哥': '多哥',
                        '多明尼加共和国': '多明尼加共和国', '奈': '奈及利亚', '奥': '奥地利', '委': '委内瑞拉',
                        '孟': '孟加拉', '安': '安哥拉', '安提瓜和巴布达': '安提瓜和巴布达', '密': '密克罗尼西亚联邦',
                        '尼': '尼泊尔', '尼加拉瓜': '尼加拉瓜', '尼日尔': '尼日尔', '巴': '巴基斯坦',
                        '巴勒斯坦国': '巴勒斯坦国', '巴哈马': '巴哈马', '巴巴多斯': '巴巴多斯',
                        '巴布亚新几内亚': '巴布亚新几内亚', '巴拉圭': '巴拉圭', '巴拿马': '巴拿马', '巴林': '巴林',
                        '巴西': '巴西', '布': '布基纳法索', '布隆迪': '布隆迪', '希': '希腊', '库': '库拉索',
                        '德': '德国', '意': '意大利', '所罗门群岛': '所罗门群岛', '拉': '拉脱维亚', '挪': '挪威',
                        '捷': '捷克', '摩': '摩洛哥', '摩尔多瓦共和国': '摩尔多瓦共和国', '文': '文莱达鲁萨兰国',
                        '斐': '斐济', '斯': '斯里兰卡', '斯洛伐克': '斯洛伐克', '斯洛文尼亚': '斯洛文尼亚',
                        '新': '新加坡', '新喀里多尼亚': '新喀里多尼亚', '新西兰': '新西兰', '日': '日本', '智': '智利',
                        '朝鲜': '朝鲜', '柬': '柬埔寨', '格': '格鲁吉亚', '格林纳达': '格林纳达', '比利时': '比利时',
                        '毛': '毛里塔尼亚', '毛里求斯': '毛里求斯', '汤': '汤加', '沙': '沙特阿拉伯', '法': '法国',
                        '法属圭亚那': '法属圭亚那', '法属波利尼西亚': '法属波利尼西亚', '波': '波兰',
                        '波多黎各': '波多黎各', '波斯尼亚和黑塞哥维那': '波斯尼亚和黑塞哥维那', '泰': '泰国',
                        '津': '津巴布韦', '洪': '洪都拉斯', '海': '海地', '澳': '澳大利亚', '爱': '爱尔兰',
                        '爱沙尼亚': '爱沙尼亚', '牙': '牙买加', '特': '特立尼达和多巴哥', '玻': '玻利维亚',
                        '瑞': '瑞典', '瑞士': '瑞士', '瓜': '瓜德罗普', '瓦': '瓦努阿图', '留': '留尼汪',
                        '白': '白俄罗斯', '科': '科特迪瓦', '科威特': '科威特', '科摩罗': '科摩罗', '秘': '秘鲁',
                        '突': '突尼斯', '立': '立陶宛', '索': '索马里', '约': '约旦', '纳': '纳米比亚', '缅': '缅甸',
                        '罗': '罗马尼亚', '美': '美国', '美属维尔京群岛': '美属维尔京群岛', '老': '老挝人民民主共和国',
                        '肯': '肯尼亚', '芬': '芬兰', '苏': '苏丹', '苏里南': '苏里南', '英': '英国', '荷': '荷兰',
                        '莫': '莫桑比克', '莱': '莱索托', '菲': '菲律宾', '萨': '萨尔瓦多', '萨摩亚': '萨摩亚',
                        '葡': '葡萄牙', '蒙': '蒙古', '西': '西班牙', '西撒哈拉': '西撒哈拉', '贝': '贝宁',
                        '赞': '赞比亚', '赤': '赤道几内亚', '越': '越南', '阿塞拜疆': '阿塞拜疆', '阿富汗': '阿富汗',
                        '阿尔及利亚': '阿尔及利亚', '阿尔巴尼亚': '阿尔巴尼亚',
                        '阿拉伯叙利亚共和国': '阿拉伯叙利亚共和国', '阿拉伯联合酋长国': '阿拉伯联合酋长国',
                        '阿曼': '阿曼', '阿根廷': '阿根廷', '阿鲁巴岛': '阿鲁巴岛', '韩': '韩国', '马': '马来西亚',
                        '马尔代夫': '马尔代夫', '马拉维': '马拉维', '马提尼克岛': '马提尼克岛', '马约特岛': '马约特岛',
                        '马耳他': '马耳他', '马达加斯加': '马达加斯加', '马里': '马里', '黎': '黎巴嫩',
                        '黑': '黑山共和国'}
discard_zh_abbr = {'也', '以', '几', '哈', '多', '所', '朝', '比', '阿'}
use_full_name_country = ['印度尼西亚', '巴西', '埃及', '阿尔及利亚', '伊拉克', '阿根廷', '阿富汗', '也门', '乌克兰',
                         '乌兹别克斯坦', '加纳', '马达加斯加', '尼日尔', '朝鲜', '阿拉伯叙利亚共和国', '马里', '马拉维',
                         '哈萨克斯坦', '几内亚', '布隆迪', '南苏丹', '比利时', '多明尼加共和国', '阿拉伯联合酋长国',
                         '巴布亚新几内亚', '阿塞拜疆', '多哥', '以色列', '瑞士', '塞拉利昂', '土库曼斯坦', '巴拉圭',
                         '尼加拉瓜', '塞尔维亚', '刚果共和国', '利比里亚', '巴勒斯坦国', '阿曼', '斯洛伐克', '新西兰',
                         '哥斯达黎加', '科威特', '巴拿马', '厄立特里亚', '乌拉圭', '波多黎各', '波斯尼亚和黑塞哥维那',
                         '摩尔多瓦共和国', '阿尔巴尼亚', '加蓬', '几内亚比绍', '斯洛文尼亚', '巴林', '塞浦路斯',
                         '爱沙尼亚', '毛里求斯', '埃斯瓦蒂尼', '吉布地', '科摩罗', '所罗门群岛', '卢森堡', '苏里南',
                         '西撒哈拉', '马耳他', '马尔代夫', '巴哈马', '马提尼克岛', '马约特岛', '法属圭亚那',
                         '新喀里多尼亚', '巴巴多斯', '法属波利尼西亚', '萨摩亚', '圣卢西亚', '塞舌尔', '格林纳达',
                         '阿鲁巴岛', '圣文森特和格林纳丁斯', '安提瓜和巴布达', '美属维尔京群岛']

helper_country_name_dict = {
    '俄罗斯联邦': ['俄国', '俄罗斯']
}

def helper_convert_country_name(country_name):
    for k,v in helper_country_name_dict.items():
        if country_name in v:
            return k

    return country_name

def get_country_zh_abbr(country):
    """
    获取目标国家中文简称
    """
    country_name = helper_convert_country_name(country)

    for k,v in country_zh_abbr_dict.items():
        if country_name == v:
            return k
    else:
        logger.warning(f'unknown {country}')
        return "未知的国家全称名"


def get_full_country_name(country_abbr):
    if country_abbr in country_zh_abbr_dict:
        return country_zh_abbr_dict[country_abbr]
    else:
        return "未知的国家名缩写"